using System;
using System.Collections.Generic;
using System.Text;
using Ruon;

namespace ServiceAgentSample
{
    /// <summary>
    /// This is an example of a trivial agent that can be loaded by the ServiceLoader.<br/>
    /// <br/>
    /// A non-trivial agent would of course have more activities in the constructor and would
    /// probably override Monitor to poll the state of the resoures being monitored. CoffeeOn shows how it's done.
    /// </summary>
    [AgentAttributes("sample.trivialagent", "R-U-ON Trivial Agent", "This is just a trivial sample agent")]
    public class TrivialAgent:ServiceAgent
    {
        /// <summary>
        /// Constructor, HAS to have this signature
        /// </summary>
        public TrivialAgent(IServiceProcess serviceProcess)
            : base("TrivialAgent", "1.0", "[SECRET ID GOES HERE (take it from the account settings page)]",
              -1, null, null, serviceProcess)
        {
        }
    }
}
